<!DOCTYPE html>
<html lang="en">

<head>

    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Danh sách đơn hàng</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
    <div class="container-fluid">
        <div class="row">
            <div class="col-12">
                <h2 class="text-center">Danh sách đơn hàng</h2>
                <table class="table text-center table-striped" id="table-order">
                    <tr>
                        <th scope="col">Order ID</th>
                        <th scope="col">Kích cỡ combo</th>
                        <th scope="col">Loại pizza</th>
                        <th scope="col">Nước uống</th>
                        <th scope="col">Thành tiền</th>
                        <th scope="col">Họ và tên</th>
                        <th scope="col">Số điện thoại</th>
                        <th scope="col">Trạng thái</th>
                        <th scope="col">Chi tiết</th>
                    </tr>
            </div>
        </div>
    </div>

    <script>
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gBaseUrl = "http://42.115.221.44:8080/devcamp-pizza365/orders";
        const gDETAIL_FORM_URL = "orderdetail.html";
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gEND_OF_TABLE = -1;
        const gCELL_ID = 0;
        const gCELL_COMBO = 1;
        const gCELL_PIZZA = 2;
        const gCELL_DRINK = 3;
        const gCELL_MONEY = 4;
        const gCELL_NAME = 5;
        const gCELL_PHONENUM = 6;
        const gCELL_STATUS = 7;
        const gCELL_CHITIET = 8;

        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        function onPageLoading() {
            loadDataOrder();
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        function loadDataOrder() {
            var xmlHttpGetAllOrder = new XMLHttpRequest();
            xmlHttpGetAllOrder.open("GET", gBaseUrl, true);
            xmlHttpGetAllOrder.send();
            xmlHttpGetAllOrder.onreadystatechange =
                function () {
                    if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                        var vOrderList = JSON.parse(xmlHttpGetAllOrder.responseText);
                        insertRowToTable(vOrderList);
                    }
                }
        }

        function insertRowToTable(paramListOrder) {
            var vTableOrder = document.getElementById("table-order");
            for (var bIndex = 0; bIndex < paramListOrder.length; bIndex++) {
                var bNewRow = vTableOrder.insertRow(gEND_OF_TABLE);
                var vCellId = bNewRow.insertCell(gCELL_ID);
                var vCellCombo = bNewRow.insertCell(gCELL_COMBO);
                var vCellPizza = bNewRow.insertCell(gCELL_PIZZA);
                var vCellDrink = bNewRow.insertCell(gCELL_DRINK);
                var vCellMoney = bNewRow.insertCell(gCELL_MONEY);
                var vCellName = bNewRow.insertCell(gCELL_NAME);
                var vCellPhonenum = bNewRow.insertCell(gCELL_PHONENUM);
                var vCellStatus = bNewRow.insertCell(gCELL_STATUS);
                var vCellChitiet = bNewRow.insertCell(gCELL_CHITIET);

                vCellId.innerHTML = paramListOrder[bIndex].orderId;
                vCellCombo.innerHTML = paramListOrder[bIndex].kichCo;
                vCellPizza.innerHTML = paramListOrder[bIndex].loaiPizza;
                vCellDrink.innerHTML = paramListOrder[bIndex].idLoaiNuocUong;
                vCellMoney.innerHTML = paramListOrder[bIndex].thanhTien;
                vCellName.innerHTML = paramListOrder[bIndex].hoTen;
                vCellPhonenum.innerHTML = paramListOrder[bIndex].soDienThoai;
                vCellStatus.innerHTML = paramListOrder[bIndex].trangThai;
                var vNewBtnChiTiet = document.createElement("button");
                vNewBtnChiTiet.className = "btn btn-success";
                vNewBtnChiTiet.innerHTML = "Chi tiết";
                vNewBtnChiTiet.setAttribute("data-id", paramListOrder[bIndex].id);
                vNewBtnChiTiet.setAttribute("data-orderid", paramListOrder[bIndex].orderId);
                vNewBtnChiTiet.onclick = function () {
                    console.log("%c ID: " + this.dataset.id, "color: red");
                    console.log("Order ID: " + this.dataset.orderid);
                    openOrderDetail(this.dataset.orderid, this.dataset.id);
                }
                vCellChitiet.appendChild(vNewBtnChiTiet);
                vTableOrder.appendChild(bNewRow);
            }
        }

        function openOrderDetail(paramOrderID, paramID) {
            var vURLSiteOpen = gDETAIL_FORM_URL + "?" + "orderId=" + paramOrderID + "&id=" + paramID;
            window.location.href = vURLSiteOpen;
        }
    </script>
</body>

</html>